## cmake-bootstrap-4.1.2-1.src.tar.zst

=== Tests/CPackComponentsPrefix/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(CPackComponentsPrefix NONE)

install(FILES file-runtime.txt
        DESTINATION bin COMPONENT Runtime)
install(FILES file-development.txt
        DESTINATION lib COMPONENT Development)

set(CPACK_PACKAGE_CONTACT "None") # mandatory for DEB generator
set(CPACK_COMPONENT_INCLUDE_TOPLEVEL_DIRECTORY 1)
set(CPACK_COMPONENTS_ALL Development)
set(CPACK_ARCHIVE_COMPONENT_INSTALL 1)
set(CPACK_PACKAGING_INSTALL_PREFIX "/opt/My-1.0")
include(CPack)

=== Tests/CudaOnly/CompileFlags/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)
project(CompileFlags CUDA)

if(CMake_TEST_CUDA_ARCH)
  set(arch ${CMake_TEST_CUDA_ARCH})
else()
  set(arch 52)
endif()

add_executable(CudaOnlyCompileFlags main.cu)
target_compile_definitions(CudaOnlyCompileFlags PRIVATE EXPECT_CUDA_ARCH=${arch})

# Try passing CUDA architecture flags explicitly.
if(CMAKE_CUDA_COMPILER_ID STREQUAL "NVIDIA")
  target_compile_options(CudaOnlyCompileFlags PRIVATE
    -gencode arch=compute_${arch},code=compute_${arch}
  )
  set_property(TARGET CudaOnlyCompileFlags PROPERTY CUDA_ARCHITECTURES)
else()
  set_property(TARGET CudaOnlyCompileFlags PROPERTY CUDA_ARCHITECTURES ${arch}-real)
endif()

target_compile_options(CudaOnlyCompileFlags PRIVATE -DALWAYS_DEFINE)

=== Help/guide/tutorial/Step4/CMakeLists.txt ===
# TODO 1: Update the minimum required version to 3.15

cmake_minimum_required(VERSION 3.10)

# set the project name and version
project(Tutorial VERSION 1.0)

# specify the C++ standard
add_library(tutorial_compiler_flags INTERFACE)
target_compile_features(tutorial_compiler_flags INTERFACE cxx_std_11)

# TODO 2: Create helper variables to determine which compiler we are using:
# * Create a new variable gcc_like_cxx that is true if we are using CXX and
#   any of the following compilers: ARMClang, AppleClang, Clang, GNU, LCC
# * Create a new variable msvc_cxx that is true if we are using CXX and MSVC
# Hint: Use set() and COMPILE_LANG_AND_ID

# TODO 3: Add warning flag compile options to the interface library
# tutorial_compiler_flags.
# * For gcc_like_cxx, add flags -Wall;-Wextra;-Wshadow;-Wformat=2;-Wunused
# * For msvc_cxx, add flags -W3
# Hint: Use target_compile_options()

# TODO 4: With nested generator expressions, only use the flags for the
# build-tree
# Hint: Use BUILD_INTERFACE

# configure a header file to pass some of the CMake settings
# to the source code
configure_file(TutorialConfig.h.in TutorialConfig.h)

# add the MathFunctions library
add_subdirectory(MathFunctions)

# add the executable
add_executable(Tutorial tutorial.cxx)

target_link_libraries(Tutorial PUBLIC MathFunctions tutorial_compiler_flags)

# add the binary tree to the search path for include files
# so that we will find TutorialConfig.h
target_include_directories(Tutorial PUBLIC
                           "${PROJECT_BINARY_DIR}"
                           )

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=cmake
pkgname="${_realname}-bootstrap"
pkgver=4.1.2
pkgrel=1
pkgdesc="A cross-platform open-source make system"
arch=('i686' 'x86_64')
url="https://www.cmake.org/"
msys2_repository_url="https://gitlab.kitware.com/cmake/cmake"
msys2_references=(
  "anitya: 306"
  "cpe: cpe:2.3:a:cmake_project:cmake"
)
license=(spdx:BSD-3-Clause)
makedepends=('gcc'
             'make')
depends=('gcc-libs')
conflicts=('cmake' 'cmake-emacs' 'cmake-vim')
provides=("cmake=$pkgver")
source=(https://www.cmake.org/files/v${pkgver%.*}/${_realname}-${pkgver}.tar.gz)
sha256sums=('643f04182b7ba323ab31f526f785134fb79cba3188a852206ef0473fee282a15')

build() {
  [[ -d ${srcdir}/build-${CARCH} ]] && rm -rf ${srcdir}/build-${CARCH}
  mkdir -p ${srcdir}/build-${CARCH}
  cd ${srcdir}/build-${CARCH}

  "${srcdir}/${_realname}-${pkgver}/configure" \
    --prefix=/usr \
    --no-system-libs \
    --no-qt-gui \
    --parallel="$(nproc)" \
    --mandir=share/man \
    --docdir="share/doc/${_realname}" \
    --datadir="share/${_realname}" \
    -- -DCMAKE_USE_OPENSSL=OFF

  make
}

package() {
  cd ${srcdir}/build-${CARCH}

  make DESTDIR="${pkgdir}" install

  install -Dm644 ${srcdir}/${_realname}-${pkgver}/LICENSE.rst \
    ${pkgdir}/usr/share/licenses/${pkgname}/LICENSE
}
